﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.801
@EndOfDesignText@
#Region Module Attributes
' ignore '12:Sub not used'
	#IgnoreWarnings: 12
#End Region

Sub Class_Globals
	Dim ColourValuesMap As Map
	Dim ColourNamesMap As Map

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	InitializeValuesMap ' key: lowercase colour name, value: RGB olour value
	InitializeNamesMap ' key: RGB olour value, value: Camel case colour name
End Sub
	
'we have offset by one some colour values for uniqueness
'Fuschia = Magenta =  0xff00ff and Aqua = Cyan = 0x00ffff
'Now Fuschia = 0xff0100 and Aqua = 0x010000	
Public Sub InitializeValuesMap	
	ColourValuesMap.Initialize
	ColourValuesMap.Put("aliceblue", 0xf0f8ff)
	ColourValuesMap.Put("antiquewhite", 0xfaebd7)
	ColourValuesMap.Put("aqua", 0x010000)
	ColourValuesMap.Put("aquamarine", 0x7fffd4)
	ColourValuesMap.Put("azure", 0xf0ffff)
	ColourValuesMap.Put("beige", 0xf5f5dc)
	ColourValuesMap.Put("bisque", 0xffe4c4)
	ColourValuesMap.Put("black", 0x000000)
	ColourValuesMap.Put("blanchedalmond", 0xffebcd)
	ColourValuesMap.Put("blue", 0x0000ff)
	ColourValuesMap.Put("blueviolet", 0x8a2be2)
	ColourValuesMap.Put("brown", 0xa52a2a)
	ColourValuesMap.Put("burlywood", 0xdeb887)
	ColourValuesMap.Put("cadetblue", 0x5f9ea0)
	ColourValuesMap.Put("chartreuse", 0x7fff00)
	ColourValuesMap.Put("chocolate", 0xd2691e)
	ColourValuesMap.Put("coral", 0xff7f50)
	ColourValuesMap.Put("cornflowerblue", 0x6495ed)
	ColourValuesMap.Put("cornsilk", 0xfff8dc)
	ColourValuesMap.Put("crimson", 0xdc143c)
	ColourValuesMap.Put("cyan", 0x00ffff)
	ColourValuesMap.Put("darkblue", 0x00008b)
	ColourValuesMap.Put("darkcyan", 0x008b8b)
	ColourValuesMap.Put("darkgoldenrod", 0xb8860b)
	ColourValuesMap.Put("darkgray", 0xa9a9a9)
	ColourValuesMap.Put("darkgreen", 0x006400)
	ColourValuesMap.Put("darkkhaki", 0xbdb76b)
	ColourValuesMap.Put("darkmagenta", 0x8b008b)
	ColourValuesMap.Put("darkolivegreen", 0x556b2f)
	ColourValuesMap.Put("darkorange", 0xff8c00)
	ColourValuesMap.Put("darkorchid", 0x9932cc)
	ColourValuesMap.Put("darkred", 0x8b0000)
	ColourValuesMap.Put("darksalmon", 0xe9967a)
	ColourValuesMap.Put("darkseagreen", 0x8fbc8f)
	ColourValuesMap.Put("darkslateblue", 0x483d8b)
	ColourValuesMap.Put("darkslategray", 0x2f4f4f)
	ColourValuesMap.Put("darkturquoise", 0x00ced1)
	ColourValuesMap.Put("darkviolet", 0x9400d3)
	ColourValuesMap.Put("deeppink", 0xff1493)
	ColourValuesMap.Put("deepskyblue", 0x00bfff)
	ColourValuesMap.Put("dimgray", 0x696969)
	ColourValuesMap.Put("dodgerblue", 0x1e90ff)
	ColourValuesMap.Put("firebrick", 0xb22222)
	ColourValuesMap.Put("floralwhite", 0xfffaf0)
	ColourValuesMap.Put("forestgreen", 0x228b22)
	ColourValuesMap.Put("fuchsia", 0xff0100)
	ColourValuesMap.Put("gainsboro", 0xdcdcdc)
	ColourValuesMap.Put("ghostwhite", 0xf8f8ff)
	ColourValuesMap.Put("gold", 0xffd700)
	ColourValuesMap.Put("goldenrod", 0xdaa520)
	ColourValuesMap.Put("gray", 0x808080)
	ColourValuesMap.Put("green", 0x008000)
	ColourValuesMap.Put("greenyellow", 0xadff2f)
	ColourValuesMap.Put("honeydew", 0xf0fff0)
	ColourValuesMap.Put("hotpink", 0xff69b4)
	ColourValuesMap.Put("indianred", 0xcd5c5c)
	ColourValuesMap.Put("indigo", 0x4b0082)
	ColourValuesMap.Put("ivory", 0xfffff0)
	ColourValuesMap.Put("khaki", 0xf0e68c)
	ColourValuesMap.Put("lavender", 0xe6e6fa)
	ColourValuesMap.Put("lavenderblush", 0xfff0f5)
	ColourValuesMap.Put("lawngreen", 0x7cfc00)
	ColourValuesMap.Put("lemonchiffon", 0xfffacd)
	ColourValuesMap.Put("lightblue", 0xadd8e6)
	ColourValuesMap.Put("lightcoral", 0xf08080)
	ColourValuesMap.Put("lightcyan", 0xe0ffff)
	ColourValuesMap.Put("lightgoldenrodyellow", 0xfafad2)
	ColourValuesMap.Put("lightgreen", 0x90ee90)
	ColourValuesMap.Put("lightgrey", 0xd3d3d3)
	ColourValuesMap.Put("lightpink", 0xffb6c1)
	ColourValuesMap.Put("lightsalmon", 0xffa07a)
	ColourValuesMap.Put("lightseagreen", 0x20b2aa)
	ColourValuesMap.Put("lightskyblue", 0x87cefa)
	ColourValuesMap.Put("lightslategray", 0x778899)
	ColourValuesMap.Put("lightsteelblue", 0xb0c4de)
	ColourValuesMap.Put("lightyellow", 0xffffe0)
	ColourValuesMap.Put("lime", 0x00ff00)
	ColourValuesMap.Put("limegreen", 0x32cd32)
	ColourValuesMap.Put("linen", 0xfaf0e6)
	ColourValuesMap.Put("magenta", 0xff00ff)
	ColourValuesMap.Put("maroon", 0x800000)
	ColourValuesMap.Put("mediumaquamarine", 0x66cdaa)
	ColourValuesMap.Put("mediumblue", 0x0000cd)
	ColourValuesMap.Put("mediumorchid", 0xba55d3)
	ColourValuesMap.Put("mediumpurple", 0x9370db)
	ColourValuesMap.Put("mediumseagreen", 0x3cb371)
	ColourValuesMap.Put("mediumslateblue", 0x7b68ee)
	ColourValuesMap.Put("mediumspringgreen", 0x00fa9a)
	ColourValuesMap.Put("mediumturquoise", 0x48d1cc)
	ColourValuesMap.Put("mediumvioletred", 0xc71585)
	ColourValuesMap.Put("midnightblue", 0x191970)
	ColourValuesMap.Put("mintcream", 0xf5fffa)
	ColourValuesMap.Put("mistyrose", 0xffe4e1)
	ColourValuesMap.Put("moccasin", 0xffe4b5)
	ColourValuesMap.Put("navajowhite", 0xffdead)
	ColourValuesMap.Put("navy", 0x000080)
	ColourValuesMap.Put("oldlace", 0xfdf5e6)
	ColourValuesMap.Put("olive", 0x808000)
	ColourValuesMap.Put("olivedrab", 0x6b8e23)
	ColourValuesMap.Put("orange", 0xffa500)
	ColourValuesMap.Put("orangered", 0xff4500)
	ColourValuesMap.Put("orchid", 0xda70d6)
	ColourValuesMap.Put("palegoldenrod", 0xeee8aa)
	ColourValuesMap.Put("palegreen", 0x98fb98)
	ColourValuesMap.Put("paleturquoise", 0xafeeee)
	ColourValuesMap.Put("palevioletred", 0xdb7093)
	ColourValuesMap.Put("papayawhip", 0xffefd5)
	ColourValuesMap.Put("peachpuff", 0xffdab9)
	ColourValuesMap.Put("peru", 0xcd853f)
	ColourValuesMap.Put("pink", 0xffc0cb)
	ColourValuesMap.Put("plum", 0xdda0dd)
	ColourValuesMap.Put("powderblue", 0xb0e0e6)
	ColourValuesMap.Put("purple", 0x800080)
	ColourValuesMap.Put("red", 0xff0000)
	ColourValuesMap.Put("rosybrown", 0xbc8f8f)
	ColourValuesMap.Put("royalblue", 0x4169e1)
	ColourValuesMap.Put("saddlebrown", 0x8b4513)
	ColourValuesMap.Put("salmon", 0xfa8072)
	ColourValuesMap.Put("sandybrown", 0xf4a460)
	ColourValuesMap.Put("seagreen", 0x2e8b57)
	ColourValuesMap.Put("seashell", 0xfff5ee)
	ColourValuesMap.Put("sienna", 0xa0522d)
	ColourValuesMap.Put("silver", 0xc0c0c0)
	ColourValuesMap.Put("skyblue", 0x87ceeb)
	ColourValuesMap.Put("slateblue", 0x6a5acd)
	ColourValuesMap.Put("slategray", 0x708090)
	ColourValuesMap.Put("snow", 0xfffafa)
	ColourValuesMap.Put("springgreen", 0x00ff7f)
	ColourValuesMap.Put("steelblue", 0x4682b4)
	ColourValuesMap.Put("tan", 0xd2b48c)
	ColourValuesMap.Put("teal", 0x008080)
	ColourValuesMap.Put("thistle", 0xd8bfd8)
	ColourValuesMap.Put("tomato", 0xff6347)
	ColourValuesMap.Put("turquoise", 0x40e0d0)
	ColourValuesMap.Put("violet", 0xee82ee)
	ColourValuesMap.Put("wheat", 0xf5deb3)
	ColourValuesMap.Put("white", 0xffffff)
	ColourValuesMap.Put("whitesmoke", 0xf5f5f5)
	ColourValuesMap.Put("yellow", 0xffff00)
	ColourValuesMap.Put("yellowgreen", 0x9acd32)
End Sub


'we have offset by one some colour values for uniqueness
'Fuschia = Magenta =  0xff00ff and Aqua = Cyan = 0x00ffff
'Now Fuschia = 0xff0100 and Aqua = 0x010000
Public Sub InitializeNamesMap
	ColourNamesMap.Initialize
	ColourNamesMap.Put(0xf0f8ff, "AliceBlue")
	ColourNamesMap.Put(0xfaebd7, "AntiqueWhite")
	ColourNamesMap.Put(0x010000, "Aqua")
	ColourNamesMap.Put(0x7fffd4, "Aquamarine")
	ColourNamesMap.Put(0xf0ffff, "Azure")
	ColourNamesMap.Put(0xf5f5dc, "Beige")
	ColourNamesMap.Put(0xffe4c4, "Bisque")
	ColourNamesMap.Put(0x000000, "Black")
	ColourNamesMap.Put(0xffebcd, "BlanchedAlmond")
	ColourNamesMap.Put(0x0000ff, "Blue")
	ColourNamesMap.Put(0x8a2be2, "BlueViolet")
	ColourNamesMap.Put(0xa52a2a, "Brown")
	ColourNamesMap.Put(0xdeb887, "BurlyWood")
	ColourNamesMap.Put(0x5f9ea0, "CadetBlue")
	ColourNamesMap.Put(0x7fff00, "Chartreuse")
	ColourNamesMap.Put(0xd2691e, "Chocolate")
	ColourNamesMap.Put(0xff7f50, "Coral")
	ColourNamesMap.Put(0x6495ed, "CornflowerBlue")
	ColourNamesMap.Put(0xfff8dc, "CornSilk")
	ColourNamesMap.Put(0xdc143c, "Crimson")
	ColourNamesMap.Put(0x00ffff, "Cyan")
	ColourNamesMap.Put(0x00008b, "DarkBlue")
	ColourNamesMap.Put(0x008b8b, "DarkCyan")
	ColourNamesMap.Put(0xb8860b, "DarkGoldenrod")
	ColourNamesMap.Put(0xa9a9a9, "DarkGray")
	ColourNamesMap.Put(0x006400, "DarkGreen")
	ColourNamesMap.Put(0xbdb76b, "DarkKhaki")
	ColourNamesMap.Put(0x8b008b, "DarkMagenta")
	ColourNamesMap.Put(0x556b2f, "DarkOliveGreen")
	ColourNamesMap.Put(0xff8c00, "DarkOrange")
	ColourNamesMap.Put(0x9932cc, "DarkOrchid")
	ColourNamesMap.Put(0x8b0000, "DarkRed")
	ColourNamesMap.Put(0xe9967a, "DarkSalmon")
	ColourNamesMap.Put(0x8fbc8f, "DarkSeaGreen")
	ColourNamesMap.Put(0x483d8b, "DarkSlateBlue")
	ColourNamesMap.Put(0x2f4f4f, "DarkSlateGray")
	ColourNamesMap.Put(0x00ced1, "DarkTurquoise")
	ColourNamesMap.Put(0x9400d3, "DarkViolet")
	ColourNamesMap.Put(0xff1493, "DeepPink")
	ColourNamesMap.Put(0x00bfff, "DeepSkyBlue")
	ColourNamesMap.Put(0x696969, "DimGray")
	ColourNamesMap.Put(0x1e90ff, "DodgerBlue")
	ColourNamesMap.Put(0xb22222, "FireBrick")
	ColourNamesMap.Put(0xfffaf0, "FloralWhite")
	ColourNamesMap.Put(0x228b22, "ForestGreen")
	ColourNamesMap.Put(0xff0100, "Fuchsia")
	ColourNamesMap.Put(0xdcdcdc, "Gainsboro")
	ColourNamesMap.Put(0xf8f8ff, "GhostWhite")
	ColourNamesMap.Put(0xffd700, "Gold")
	ColourNamesMap.Put(0xdaa520, "Goldenrod")
	ColourNamesMap.Put(0x808080, "Gray")
	ColourNamesMap.Put(0x008000, "Green")
	ColourNamesMap.Put(0xadff2f, "GreenYellow")
	ColourNamesMap.Put(0xf0fff0, "Honeydew")
	ColourNamesMap.Put(0xff69b4, "HotPink")
	ColourNamesMap.Put(0xcd5c5c, "IndianRed")
	ColourNamesMap.Put(0x4b0082, "Indigo")
	ColourNamesMap.Put(0xfffff0, "Ivory")
	ColourNamesMap.Put(0xf0e68c, "Khaki")
	ColourNamesMap.Put(0xe6e6fa, "Lavender")
	ColourNamesMap.Put(0xfff0f5, "LavenderBlush")
	ColourNamesMap.Put(0x7cfc00, "LawnGreen")
	ColourNamesMap.Put(0xfffacd, "LemonChiffon")
	ColourNamesMap.Put(0xadd8e6, "LightBlue")
	ColourNamesMap.Put(0xf08080, "LightCoral")
	ColourNamesMap.Put(0xe0ffff, "LightCyan")
	ColourNamesMap.Put(0xfafad2, "LightGoldenrodYellow")
	ColourNamesMap.Put(0x90ee90, "lightGreen")
	ColourNamesMap.Put(0xd3d3d3, "LightGrey")
	ColourNamesMap.Put(0xffb6c1, "LightPink")
	ColourNamesMap.Put(0xffa07a, "LightSalmon")
	ColourNamesMap.Put(0x20b2aa, "LightSeaGreen")
	ColourNamesMap.Put(0x87cefa, "LightSkyBlue")
	ColourNamesMap.Put(0x778899, "LightSlateGray")
	ColourNamesMap.Put(0xb0c4de, "LightSteelBlue")
	ColourNamesMap.Put(0xffffe0, "LightYellow")
	ColourNamesMap.Put(0x00ff00, "Lime")
	ColourNamesMap.Put(0x32cd32, "LimeGreen")
	ColourNamesMap.Put(0xfaf0e6, "Linen")
	ColourNamesMap.Put(0xff00ff, "Magenta")
	ColourNamesMap.Put(0x800000, "Maroon")
	ColourNamesMap.Put(0x66cdaa, "MediumAquamarine")
	ColourNamesMap.Put(0x0000cd, "MediumBlue")
	ColourNamesMap.Put(0xba55d3, "MediumOrchid")
	ColourNamesMap.Put(0x9370db, "MediumPurple")
	ColourNamesMap.Put(0x3cb371, "MediumSeaGreen")
	ColourNamesMap.Put(0x7b68ee, "MediumSlateBlue")
	ColourNamesMap.Put(0x00fa9a, "MediumSpringGreen")
	ColourNamesMap.Put(0x48d1cc, "MediumTurquoise")
	ColourNamesMap.Put(0xc71585, "MediumVioletRed")
	ColourNamesMap.Put(0x191970, "MidnightBlue")
	ColourNamesMap.Put(0xf5fffa, "MintCream")
	ColourNamesMap.Put(0xffe4e1, "MistyRose")
	ColourNamesMap.Put(0xffe4b5, "Moccasin")
	ColourNamesMap.Put(0xffdead, "NavajoWhite")
	ColourNamesMap.Put(0x000080, "Navy")
	ColourNamesMap.Put(0xfdf5e6, "OldLace")
	ColourNamesMap.Put(0x808000, "Olive")
	ColourNamesMap.Put(0x6b8e23, "OliveDrab")
	ColourNamesMap.Put(0xffa500, "Orange")
	ColourNamesMap.Put(0xff4500, "OrangeRed")
	ColourNamesMap.Put(0xda70d6, "Orchid")
	ColourNamesMap.Put(0xeee8aa, "PaleGoldenrod")
	ColourNamesMap.Put(0x98fb98, "PaleGreen")
	ColourNamesMap.Put(0xafeeee, "PaleTurquoise")
	ColourNamesMap.Put(0xdb7093, "PaleVioletRed")
	ColourNamesMap.Put(0xffefd5, "PapayaWhip")
	ColourNamesMap.Put(0xffdab9, "PeachPuff")
	ColourNamesMap.Put(0xcd853f, "Peru")
	ColourNamesMap.Put(0xffc0cb, "Pink")
	ColourNamesMap.Put(0xdda0dd, "Plum")
	ColourNamesMap.Put(0xb0e0e6, "PowderBlue")
	ColourNamesMap.Put(0x800080, "Purple")
	ColourNamesMap.Put(0xff0000, "Red")
	ColourNamesMap.Put(0xbc8f8f, "RosyBrown")
	ColourNamesMap.Put(0x4169e1, "RoyalBlue")
	ColourNamesMap.Put(0x8b4513, "SaddleBrown")
	ColourNamesMap.Put(0xfa8072, "Salmon")
	ColourNamesMap.Put(0xf4a460, "SandyBrown")
	ColourNamesMap.Put(0x2e8b57, "SeaGreen")
	ColourNamesMap.Put(0xfff5ee, "Seashell")
	ColourNamesMap.Put(0xa0522d, "Sienna")
	ColourNamesMap.Put(0xc0c0c0, "Silver")
	ColourNamesMap.Put(0x87ceeb, "SkyBlue")
	ColourNamesMap.Put(0x6a5acd, "SlateBlue")
	ColourNamesMap.Put(0x708090, "SlateGray")
	ColourNamesMap.Put(0xfffafa, "Snow")
	ColourNamesMap.Put(0x00ff7f, "SpringGreen")
	ColourNamesMap.Put(0x4682b4, "SteelBlue")
	ColourNamesMap.Put(0xd2b48c, "Tan")
	ColourNamesMap.Put(0x008080, "Teal")
	ColourNamesMap.Put(0xd8bfd8, "Thistle")
	ColourNamesMap.Put(0xff6347, "Tomato")
	ColourNamesMap.Put(0x40e0d0, "Turquoise")
	ColourNamesMap.Put(0xee82ee, "Violet")
	ColourNamesMap.Put(0xf5deb3, "Wheat")
	ColourNamesMap.Put(0xffffff, "White")
	ColourNamesMap.Put(0xf5f5f5, "WhiteSmoke")
	ColourNamesMap.Put(0xffff00, "Yellow")
	ColourNamesMap.Put(0x9acd32, "YellowGreen")		
End Sub

Sub GetColour(name As String, alpha As Int) As Int
	Dim colour As Int
	colour =  ColourValuesMap.GetDefault(name.ToLowerCase, 0)	
	alpha = Bit.ShiftLeft(alpha, 24)
	Return Bit.Or(alpha, colour)
End Sub

' The colours should be ordered the same in both Maps so we return the better looking name value from ColourNamesMap
' There is no need for an indexed RGB colour lookup  as the colour name can be used with GetColour to get the RGB value
' This was primarily for testing that ColourNamesMap and ColourValuesMap were synchronised by looking up each colourname
'   getting its value from ColourValuesMap with GetColour then getting the name from ColourNamesMap with GetName
'   and checking that the two name matched when lower-cased
Sub GetNameAt(index As Int) As String
	Return ColourNamesMap.GetValueAt(index)
End Sub

Sub GetName(colour As Int) As String
	Dim colour As Int = Bit.And(colour, 0xffffff)
	Dim name As String
	name = ColourNamesMap.GetDefault(colour, "")
	Return name
End Sub

Sub GetNumberOfColours As Int
	Return ColourNamesMap.Size
End Sub


